Adding "Real Time KVM" support
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16
17   # OPNFV Default Environment and Network settings
18   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
19   DEPLOY_OPTIONS+=" -e network-environment.yaml"
20
21   # Custom Deploy Environment Templates
22   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
23     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
24       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
25     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
26       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
27       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
28         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
29       fi
30     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
31       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
32     else
33       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
34     fi
35     SDN_IMAGE=opendaylight
36   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
37     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
38     SDN_IMAGE=opendaylight
39   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
40     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
41     exit 1
42     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
43     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
44     #else
45     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
46     #fi
47     #SDN_IMAGE=onos
48   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
49     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
50     exit 1
51   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
52     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
53     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
54       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-networking-vpp.yaml"
55     fi
56     SDN_IMAGE=opendaylight
57   else
58     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
59     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
60     exit 1
61   fi
62
63   # Enable Tacker
64   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
65     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
66   fi
67
68   # Enable Congress
69   if [ "${deploy_options_array['congress']}" == 'True' ]; then
70     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
71   fi
72
73   # Enable Real Time Kernel (kvm4nfv)
74   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
75     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
76   fi
77
78   # Make sure the correct overcloud image is available
79   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
80       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
81       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
82       exit 1
83   fi
84
85   echo "Copying overcloud image to Undercloud"
86   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
87   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
88
89   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
90       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
91       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
92       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
93                                                --run-command "systemctl enable zrpcd" \
94                                                -a overcloud-full.qcow2
95 EOI
96   fi
97
98   # Install ovs-dpdk inside the overcloud image if it is enabled.
99   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
100     # install dpdk packages before ovs
101     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
102
103     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
104       cat << EOF > vfio_pci.modules
105 #!/bin/bash
106 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
107 EOF
108
109       cat << EOF > uio_pci_generic.modules
110 #!/bin/bash
111 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
112 EOF
113
114       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
115                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
116                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
117                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
118                                                -a overcloud-full.qcow2
119
120       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
121         LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/dpdk_rpms/*" \
122                                                  --run-command "sed -i '/RuntimeDirectoryMode=.*/d' /usr/lib/systemd/system/openvswitch-nonetwork.service" \
123                                                  --run-command "printf \"%s\\n\" RuntimeDirectoryMode=0775 Group=qemu UMask=0002 >> /usr/lib/systemd/system/openvswitch-nonetwork.service" \
124                                                  --run-command "sed -i 's/\\(^\\s\\+\\)\\(start_daemon "$OVS_VSWITCHD_PRIORITY"\\)/\\1umask 0002 \\&\\& \\2/' /usr/share/openvswitch/scripts/ovs-ctl" \
125                                                  -a overcloud-full.qcow2
126       fi
127
128 EOI
129
130   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
131     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
132     exit 1
133   fi
134
135   if [ "$debug" == 'TRUE' ]; then
136     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
137   fi
138
139   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
140   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
141     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
142          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
143                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
144                                                   -a overcloud-full.qcow2
145 EOI
146   fi
147
148   if [ -n "${deploy_options_array['performance']}" ]; then
149     for option in "${performance_options[@]}" ; do
150     arr=($option)
151     # use compute's kernel settings for all nodes for now.
152     if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
153       kernel_args+=" ${arr[2]}=${arr[3]}"
154     fi
155     done
156
157     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
158        sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
159        sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
160        sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
161 EOI
162   fi
163
164   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
165     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
166       sed -i "/neutron::agents::dhcp::interface_driver:/c\    neutron::agents::dhcp::interface_driver: neutron.agent.linux.interface.NSDriver" ${ENV_FILE}
167       sed -i "/neutron::agents::l3::interface_driver:/c\    neutron::agents::l3::interface_driver: neutron.agent.linux.interface.NSDriver" ${ENV_FILE}
168 EOI
169   fi
170
171   # Set ODL version accordingly
172   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
173     case "${deploy_options_array['odl_version']}" in
174       beryllium) odl_version=''
175               ;;
176       boron)  odl_version='boron'
177               ;;
178       carbon) odl_version='master'
179               ;;
180       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
181          exit 1
182          ;;
183     esac
184
185     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
186       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
187                                                --run-command "yum -y install /root/${odl_version}/*" \
188                                                -a overcloud-full.qcow2
189 EOI
190   fi
191
192
193   # check if ceph should be enabled
194   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
195     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
196   fi
197
198   # get number of nodes available in inventory
199   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
200   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
201
202   # check if HA is enabled
203   if [[ "$ha_enabled" == "True" ]]; then
204     if [ "$num_control_nodes" -lt 3 ]; then
205       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
206       exit 1
207     else
208      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
209      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
210      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
211     fi
212   else
213     if [ "$num_control_nodes" -lt 1 ]; then
214       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
215       exit 1
216     fi
217   fi
218
219   if [ "$num_compute_nodes" -le 0 ]; then
220     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
221     exit 1
222   else
223     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
224     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
225   fi
226
227   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
228
229   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
230   if [[ "$virtual" == "TRUE" ]]; then
231      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
232   fi
233
234   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
235
236   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
237 # Create a key for use by nova for live migration
238 echo "Creating nova SSH key for nova resize support"
239 ssh-keygen -f nova_id_rsa -b 1024 -P ""
240 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
241 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
242 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
243 mv -f opnfv-environment-new.yaml ${ENV_FILE}
244
245 source stackrc
246 set -o errexit
247 # Workaround for APEX-207 where sometimes swift proxy is down
248 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
249   sudo systemctl restart openstack-swift-proxy
250 fi
251 echo "Uploading overcloud glance images"
252 openstack overcloud image upload
253
254 echo "Configuring undercloud and discovering nodes"
255 openstack baremetal import --json instackenv.json
256
257 if [[ -z "$virtual" ]]; then
258   openstack baremetal introspection bulk start
259   if [[ -n "$root_disk_list" ]]; then
260     openstack baremetal configure boot --root-device=${root_disk_list}
261   else
262     openstack baremetal configure boot
263   fi
264 else
265   openstack baremetal configure boot
266 fi
267
268 echo "Configuring flavors"
269 for flavor in baremetal control compute; do
270   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
271   if openstack flavor list | grep \${flavor}; then
272     openstack flavor delete \${flavor}
273   fi
274   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
275   if ! openstack flavor list | grep \${flavor}; then
276     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
277   fi
278 done
279 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
280 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
281 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
282 echo "Configuring nameserver on ctlplane network"
283 dns_server_ext=''
284 for dns_server in ${dns_servers}; do
285   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
286 done
287 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
288 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
289 echo "Executing overcloud deployment, this should run for an extended period without output."
290 sleep 60 #wait for Hypervisor stats to check-in to nova
291 # save deploy command so it can be used for debugging
292 cat > deploy_command << EOF
293 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
294 EOF
295 EOI
296
297   if [ "$interactive" == "TRUE" ]; then
298     if ! prompt_user "Overcloud Deployment"; then
299       echo -e "${blue}INFO: User requests exit${reset}"
300       exit 0
301     fi
302   fi
303
304   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
305 source stackrc
306 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
307 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
308   $(typeset -f debug_stack)
309   debug_stack
310   exit 1
311 fi
312 EOI
313
314   # Configure DPDK
315   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
316     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
317 source stackrc
318 set -o errexit
319 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
320 echo "Running DPDK test app on \$node"
321 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
322 set -o errexit
323 sudo dpdk_helloworld --no-pci
324 sudo dpdk_nic_bind -s
325 EOF
326 done
327 EOI
328   fi
329
330   if [ "$debug" == 'TRUE' ]; then
331       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
332 source overcloudrc
333 echo "Keystone Endpoint List:"
334 openstack endpoint list
335 echo "Keystone Service List"
336 openstack service list
337 EOI
338   fi
339 }